#ifndef WEFGCR_H
#   define WEFGCR_H

WEFG_crack_surf_t *
efgcr_new_crack_surf(WEFG_superelem_t           *se,
                     int                         id,
                     WEFG_crack_surf_data_t      data,
                     WEFG_crack_surf_methods_t  *methods);

W_bool_t 
efgcr_segment_intersects_crack_surf(WEFG_eval_for_packet_t *efp,
                                    G3D_segment_t *s, WEFG_node_t *efgn,
                                    WEFG_crack_surf_t *cs,
                                    double  tol);

WEFG_pt_pos_wrt_crack_surf_enum
efgcr_node_pos_wrt_crack_surf(WEFG_crack_surf_t *cs,
                              WEFG_node_t *efgn,
                              double physical_tol);

void
efgcr_modify_crack_surf_grep(WEFG_superelem_t *se, double displ_scale, WEFG_crack_surf_t *cs);


void
efgcr_propagate(WEFG_crack_surf_t *cs);

void
efgcr_write_hexvue_postproc_file(WEFG_crack_surf_t *cs,
                                 ckit_iobuf_t IOB, char *mode);

void
efgcr_write_tecplot_postproc_file(WEFG_crack_surf_t *cs,
                                  ckit_iobuf_t IOB, char *mode,
                                  void *optdata);

void
efgcr_update_stress(WEFG_superelem_t *se, WEFG_crack_surf_t *cs);

void
efgcr_write_ve3d_loclist(WEFG_crack_surf_t *cs, FILE *stream);

void
efgcr_write_ve3d_polys(WEFG_crack_surf_t *cs, FILE *stream);

W_bool_t 
efgcr_hex_intersected_by_crack_surf(WEFG_crack_surf_t *cs,
                                    WEFG_hex_volume_t *h
                                    );

#define STALE_CRACK(cs) {INIT_TIME_STAMP((cs)->time_stamp);}

#endif /* WEFGCR_H */
