#ifndef WEFGII_H
#   define WEFGII_H

/* 
   EValuate stress intensity factors from interaction integrals.
   EValuate stress intensity factors from interaction integrals.
 */
void
efgii_sifs_volume (WEFG_superelem_t *se, /* EFG superelement */
                   W_loc_t *at_point, /* location at the front */
                   W_vect_t *forward, /* unit vector forward  */
                   W_vect_t *tangent, /* unit vector tangent to the front */
                   W_vect_t *normal, /* unit vector normal to the crack surface */
                   double hsize_forward_plus, /* forward size of
                                                         virtual extension
                                                         domain */
                   double hsize_forward_minus,/* forward size of
                                                         virtual extension
                                                         domain */
                   double hsize_tangent_plus,/* tangent size of
                                                         virtual extension
                                                         domain */
                   double hsize_tangent_minus,/* tangent size of
                                                         virtual extension
                                                         domain */
                   double hsize_normal_plus,/* normal size of
                                                         virtual extension
                                                         domain */
                   double hsize_normal_minus,/* normal size of
                                                         virtual extension
                                                         domain */
                   WEFG_tensor_prod_comp_func func, /* virtual extension function
                                      is a tensor-product function
                                      in the local coordinate system
                                      at the vertex with component f */
                   WEFG_tensor_prod_comp_der_func func_der, /* virtual extension function
                                      is a tensor-product function
                                      in the local coordinate system
                                      at the vertex with component f; this is the derivative
                                      of the component function wrt the argument */
                   double E_star, /* effective Young's modulus */
                   int subsplit, /* should
                                                            integration cells
                                                            be subdivided
                                                            for integration
                                                            of the interaction
                                                            integrals?  */
                   W_bool_t include_dynamic_effects, /* include dynamics effects?  If FALSE,
                                                      static K_i are output */
                   double *KI_dynamic, /* output: opening SIF */
                   double *KII_dynamic, /* output: shearing SIF */
                   double *KIII_dynamic, /* output: tearing SIF */
                   double *KI_equiv_dynamic, /* output: equivalent opening SIF  */
                   double *theta_dynamic /* output: angle in the forward/normal plane */
                   ) ;

#endif /* WEFGII_H */
