#ifndef WCDI_H
#   define WCDI_H

#include "Wcdtypes.h"
#include "WIutil.h"

/* INTERFACE */

W_cd_integrator_t * /* integrator */
W_cd_new_Warburton_integrator (void                    *domain, /* domain */
     W_float_t               t0, /* initial time */
     W_float_t               dt, /* time step */
     W_cdi_calc_eff_loads_proc calc_eff_loads, /* procedure to calculate effective loads */
     W_cdi_solve_for_proc      solve_for, /* procedure to solve for the primary unknowns */
     W_cdi_update_config_proc  update_config, /* procedure to update configuration */
                               W_cdi_finalize_step_proc  finalize_step, /* procedure to finalize step */
                               char *options
     );

W_cd_integrator_t *
W_cd_new_Newmark_integrator (void *domain, /* domain */
     W_float_t               t0, /* initial time */
     W_float_t               dt, /* time step */
     W_cdi_calc_eff_loads_proc calc_eff_loads, /* procedure to calculate effective loads */
     W_cdi_solve_for_proc      solve_for, /* procedure to solve for the primary unknowns */
     W_cdi_update_config_proc  update_config, /* procedure to update configuration */
                             W_cdi_finalize_step_proc  finalize_step, /* procedure to finalize step */
                             char *options
     );
void
W_cd_advance (W_cd_integrator_t *i /* integrator */);
W_float_t /* time */
W_cd_get_time (W_cd_integrator_t *i/* integrator */);
W_float_t                       /* time step */
W_cd_get_dt (W_cd_integrator_t *i/* integrator */);
double
W_cd_get_gamma(W_cd_integrator_t *i);
void
W_cd_set_gamma (W_cd_integrator_t *i, double gamma);


#endif
