#ifndef WCDTYPES_H
#   define WCDTYPES_H

#include "Wtypes.h"             /* WASP types */
#include "listP.h"		/* C-toolkit */

struct W_cd_integrator_t;

typedef void (*W_cdi_solve_for_proc)(void *domain);

typedef void (*W_cdi_calc_eff_loads_proc)(void *domain);

typedef void (*W_cdi_update_config_proc)(void *domain);


typedef W_float_t (*W_cdi_finalize_step_proc)(void *domain);

typedef void (*W_cdi_advance_cd_integrator_proc)(struct W_cd_integrator_t *i);

#define WARBURTON_CD_VARIANT 1 
#define NEWMARK_CD_VARIANT  2

/* central differences integrator */
typedef struct W_cd_integrator_t {
  void                             *domain;         /* initialized for domain */
  W_cdi_calc_eff_loads_proc         calc_eff_loads; /* calcs effect. loads at t */
  W_cdi_solve_for_proc              solve_for;      /* solves for update vector */
  W_cdi_update_config_proc          update_config;  /* update config by vector */
  W_cdi_finalize_step_proc          finalize_step;  /* change time step */
  W_float_t                         t;              /* current time */
  W_float_t                         dt;             /* time step */
  double                            gamma;          /* parameter */
  W_cdi_advance_cd_integrator_proc  advance;        /* the advance method */
}   W_cd_integrator_t;


#endif 
