/* Configuration file for the WASP library.  Note: includes the */
/* automatically generated file Wag.h */
#ifndef WCONFIG_H
#   define WCONFIG_H

/* RCSHEADER "$Id: Wconfig.h,v 1.1.1.1 2001/07/24 02:42:51 pkrysl Exp $" */

#include "Wag.h" /* automatically generated by configure */

#include <stdio.h>
#if HAVE_UNISTD_H
#   include <unistd.h>
#endif
#ifdef STDC_HEADERS
#  include <stdlib.h>
#  include <math.h>
#endif

#define UNIX

#define SEP           "/"
#define IN_SUFFIX     ".in"
#define OUT_SUFFIX    ".out"


#ifdef AIXV3
#   define CUSTOM_SIGNAL_HANDLER 1
#   define IBM_SIGNAL_HANDLING 1
#endif
#ifdef _HPUX_SOURCE
#   define CUSTOM_SIGNAL_HANDLER 1
#   define HP_SIGNAL_HANDLING 1
#endif


/* Customized error handler for common exceptions (floating point, */
/* bus error, segmentation violation, etc). */
#ifdef CUSTOM_SIGNAL_HANDLER
#   if !CUSTOM_SIGNAL_HANDLER
#      undef CUSTOM_SIGNAL_HANDLER
#   endif
#else
#   define CUSTOM_SIGNAL_HANDLER 1
#endif


/* X Window System graphic interface */
#ifdef X_XFACE 
# if !(X_XFACE)  /* not desired */
#   undef X_XFACE
# endif
#else
# define X_XFACE /* bundled */
#endif

#define WANT_VECTP_ALIASES      /* to be able to refer to vector functions */
                                /* by another (more convenient) name */
#include "Wxf.h" /* X Windows Interface include */


/* EFG additions to WASP */
#ifdef EFG_WASP 
# if !(EFG_WASP)  /* not desired */
#   undef EFG_WASP
# endif
#else
# define EFG_WASP /* bundled */
#endif



/* Use ESFLib. */
#ifdef EFG_WASP 
#   ifdef USE_ESFLIB
#      if !USE_ESFLIB
#         undef USE_ESFLIB
#      endif
#   else
#      define USE_ESFLIB 1
#   endif
#endif


/* Enable special diagonal two-point quadrature */
#ifdef EFG_WASP 
#  ifdef ENABLE_TWO_POINT_RULE
#    if !ENABLE_TWO_POINT_RULE
#       undef ENABLE_TWO_POINT_RULE
#    endif
#  else
#    define ENABLE_TWO_POINT_RULE /* bundled */
#  endif
#endif


/* Use wrap-around with the ESPACK or ESFLib. */
#ifdef EFG_WASP 
#   ifdef USE_WRAP_AROUND
#      if !USE_WRAP_AROUND
#         undef USE_WRAP_AROUND
#      endif
#   endif
#endif



/* PADOC additions to WASP */
#ifdef PADOC_WASP 
# if !(PADOC_WASP)  /* not desired */
#   undef PADOC_WASP
# endif
#endif



/* Select the integration rule for the ASQBI hexahedron */
#ifdef ASQBI_FULL_INTEGRATION
#  if !(ASQBI_FULL_INTEGRATION)
#     undef ASQBI_FULL_INTEGRATION
#  endif
#else
#  define ASQBI_FULL_INTEGRATION /* bundled */
#endif


/* Should rotational degrees of freedom be included? */
#ifdef W_ROT_DOFS
#  if W_ROT_DOFS
#    define W_ROT_DOFS 1
#  else
#    define W_ROT_DOFS 0
#  endif
#else
#  define W_ROT_DOFS 1          /* bundled */
#endif
#if W_ROT_DOFS
#  define W_NDOF_PER_NODE 6
#else
#  define W_NDOF_PER_NODE 3
#endif

/* PVM configuration; only one of the below may be defined */
#ifdef PVM_WASP_STUFF
#  define PVM_NEED_GHOST_ELEMENTS 1
#  if (!defined(PVM_WASP_MASTER)) && (!defined(PVM_WASP_WORKER))
     (Either + PVM_WASP_MASTER + or + PVM_WASP_WORKER / must ^ be & defined)
#  endif
#endif
#ifdef PVM_WASP_MASTER
#   undef  PVM_WASP_MASTER
#   define PVM_WASP_MASTER 0
#   undef  PVM_WASP_WORKER
#else
#   undef  PVM_WASP_MASTER
#endif
#ifdef PVM_WASP_WORKER
#   undef  PVM_WASP_WORKER
#   define PVM_WASP_WORKER 1
#   undef  PVM_WASP_MASTER
#else
#   undef  PVM_WASP_WORKER
#endif

#if defined(PVM_WASP_WORKER) || defined(PVM_WASP_MASTER)
#include "pvm3.h"
#endif

/* MPI configuration */
#ifdef MPI_WASP
# if !(MPI_WASP)
#   undef MPI_WASP
# endif
#endif

#if defined (MPI_WASP) /* need to have one and only one
                          of the below defined */
# if defined (MPI_WASP_ELEM_CUT)
#   if MPI_WASP_ELEM_CUT
#     define MPI_WASP_NODE_CUT 0
#   else
#     define MPI_WASP_ELEM_CUT 0
#     define MPI_WASP_NODE_CUT 1
#   endif
# endif
# if defined (MPI_WASP_NODE_CUT)
#   if MPI_WASP_NODE_CUT
#     define MPI_WASP_ELEM_CUT 0
#   else
#     define MPI_WASP_ELEM_CUT 1
#     define MPI_WASP_NODE_CUT 0
#   endif
# endif
# if !(defined (MPI_WASP_NODE_CUT) || defined (MPI_WASP_ELEM_CUT))
#   define MPI_WASP_ELEM_CUT 1  /* default */
# endif
#else
#   undef MPI_WASP_ELEM_CUT
#   undef MPI_WASP_NODE_CUT
#endif

/* Should time statistics be accumulated? */
#if ! defined (TIMED_WASP)
#  define TIMED_WASP 1          /* bundled */
#endif

#endif /* !WCONFIG_H */

