#ifndef WHISTRY_H
#   define WHISTRY_H

#include "Wtypes.h"
#include "Wutil.h"


#ifndef MAXHISTBUFFLNGTH
#  define MAXHISTBUFFLNGTH 1000       /* RAW: should be probably larger */
#endif


#define NODE_CLIENT    'N'
#define ELEM_CLIENT    'E'
#define ENERGY_CLIENT  'W'
#define DOMAIN_CLIENT  'D'
#define NEWMARK_CLIENT 'I'

void
WHR_update_history(W_history_writer_t *r, W_bool_t should_flush);

W_history_writer_t *
WHR_new_history_writer (W_domain_t *d);

W_bool_t
WHR_add_node_client(W_history_writer_t *r, W_index_t idx, char *input_line);

W_bool_t
WHR_add_elem_client(W_history_writer_t *r, W_index_t idx, char *input_line);


void
WHR_report_for_elem(W_history_writer_t *r, W_index_t idx);

void
WHR_report_for_node(W_history_writer_t *r, W_index_t idx);

W_bool_t
W_history_clients_reader(W_domain_t *d);

void
WHR_write_header(char *file, char *ytitle);

void
WHR_file_name (char *history_dir,
               char *client_data_name,
               char *buf
               );

int
WHR_store (W_history_writer_t *hw, char *hist_file_base_name, double time, double val);

#endif /* !WHISTRY_H */
