#ifndef WMAT3DUTIL_H
#   define WMAT3DUTIL_H

/* RCSHEADER "$Id: Wmat3dutil.h,v 1.7 2004/09/06 01:17:58 cvs Exp $" */

#define MAT3DUTIL_2_MAT(A_, op, B_)             \
 {                                              \
   A_[0][0] op B_[0][0];                        \
   A_[0][1] op B_[0][1];                        \
   A_[0][2] op B_[0][2];                        \
   A_[1][0] op B_[1][0];                        \
   A_[1][1] op B_[1][1];                        \
   A_[1][2] op B_[1][2];                        \
   A_[2][0] op B_[2][0];                        \
   A_[2][1] op B_[2][1];                        \
   A_[2][2] op B_[2][2];                        \
 }

#define MAT3DUTIL_3_MAT(C_, op1, A_, op2, B_)      \
 {                                                 \
   C_[0][0] op1 A_[0][0] op2 B_[0][0];             \
   C_[0][1] op1 A_[0][1] op2 B_[0][1];             \
   C_[0][2] op1 A_[0][2] op2 B_[0][2];             \
   C_[1][0] op1 A_[1][0] op2 B_[1][0];             \
   C_[1][1] op1 A_[1][1] op2 B_[1][1];             \
   C_[1][2] op1 A_[1][2] op2 B_[1][2];             \
   C_[2][0] op1 A_[2][0] op2 B_[2][0];             \
   C_[2][1] op1 A_[2][1] op2 B_[2][1];             \
   C_[2][2] op1 A_[2][2] op2 B_[2][2];             \
 }

#define MAT3DUTIL_MAT_MOD_DIAG(A_, op, VAL_)    \
 {                                              \
   A_[0][0] op VAL_;                            \
   A_[1][1] op VAL_;                            \
   A_[2][2] op VAL_;                            \
 }

#define MAT3DUTIL_DET_3X3(T3X3) (  (T3X3[0][0] * T3X3[1][1] *T3X3[2][2])    \
                                 + (T3X3[0][1] * T3X3[1][2] *T3X3[2][0])    \
                                 + (T3X3[0][2] * T3X3[1][0] *T3X3[2][1])    \
                                 - (T3X3[0][2] * T3X3[1][1] *T3X3[2][0])    \
                                 - (T3X3[0][1] * T3X3[1][0] *T3X3[2][2])    \
                                 - (T3X3[0][0] * T3X3[1][2] *T3X3[2][1]))

#define CPYT(dest, src, I, J) dest[(I)][(J)] = src[(I)][(J)]
#define MAT3DUTIL_COPY_3X3(dest, src)                                      \
   {                                                                       \
     CPYT(dest, src, 0, 0); CPYT(dest, src, 0, 1); CPYT(dest, src, 0, 2);  \
     CPYT(dest, src, 1, 0); CPYT(dest, src, 1, 1); CPYT(dest, src, 1, 2);  \
     CPYT(dest, src, 2, 0); CPYT(dest, src, 2, 1); CPYT(dest, src, 2, 2);  \
   }

#define TCPYT(dest, src, I, J) dest[(J)][(I)] = src[(I)][(J)]
#define MAT3DUTIL_COPY_TRANSP_3X3(dest, src)                                  \
   {                                                                          \
     TCPYT(dest, src, 0, 0); TCPYT(dest, src, 0, 1); TCPYT(dest, src, 0, 2);  \
     TCPYT(dest, src, 1, 0); TCPYT(dest, src, 1, 1); TCPYT(dest, src, 1, 2);  \
     TCPYT(dest, src, 2, 0); TCPYT(dest, src, 2, 1); TCPYT(dest, src, 2, 2);  \
   }


/* VP_ = A_ * V_ */
#define MAT3DUTIL_MULT_A_3X3_V_3(VP_, A_, V_)                           \
 {                                                                      \
   VP_[0]  = (A_[0][0]*V_[0] + A_[0][1]*V_[1] + A_[0][2]*V_[2]);        \
   VP_[1]  = (A_[1][0]*V_[0] + A_[1][1]*V_[1] + A_[1][2]*V_[2]);        \
   VP_[2]  = (A_[2][0]*V_[0] + A_[2][1]*V_[1] + A_[2][2]*V_[2]);        \
 } 


/* VP_ = A_ * V_ */
#define MAT3DUTIL_MULT_A_6X6_V_6(VP_, A_, V_)                           \
 {                                                                      \
   VP_[0]  = (A_[0][0]*V_[0] + A_[0][1]*V_[1] + A_[0][2]*V_[2] + A_[0][3]*V_[3] + A_[0][4]*V_[4] + A_[0][5]*V_[5]);        \
   VP_[1]  = (A_[1][0]*V_[0] + A_[1][1]*V_[1] + A_[1][2]*V_[2] + A_[1][3]*V_[3] + A_[1][4]*V_[4] + A_[1][5]*V_[5]);        \
   VP_[2]  = (A_[2][0]*V_[0] + A_[2][1]*V_[1] + A_[2][2]*V_[2] + A_[2][3]*V_[3] + A_[2][4]*V_[4] + A_[2][5]*V_[5]);        \
   VP_[3]  = (A_[3][0]*V_[0] + A_[3][1]*V_[1] + A_[3][2]*V_[2] + A_[3][3]*V_[3] + A_[3][4]*V_[4] + A_[3][5]*V_[5]);        \
   VP_[4]  = (A_[4][0]*V_[0] + A_[4][1]*V_[1] + A_[4][2]*V_[2] + A_[4][3]*V_[3] + A_[4][4]*V_[4] + A_[4][5]*V_[5]);        \
   VP_[5]  = (A_[5][0]*V_[0] + A_[5][1]*V_[1] + A_[5][2]*V_[2] + A_[5][3]*V_[3] + A_[5][4]*V_[4] + A_[5][5]*V_[5]);        \
}

#define MAT3DUTIL_MULT_A_9x9_V_9(VP_, A_, V_)	\
  {                                             \
    int i__, j__;                               \
    for (i__ = 0; i__ < 9; i__++) {             \
       VP_[i__] = 0;				\
       for (j__ = 0; j__ < 9; j__++) {          \
       VP_[i__] += A_[i__][j__] * V_[j__];        \
       }                                        \
    }                                           \
  }

#define MAT3DUTIL_MULT_V_9_A_9x9(VP_, V_, A_)   \
  {                                             \
    int i__, j__;                               \
    for (i__ = 0; i__ < 9; i__++) {             \
       VP_[i__] = 0;                             \
       for (j__ = 0; j__ < 9; j__++) {          \
       VP_[i__] += A_[j__][i__] * V_[j__];        \
       }                                        \
    }                                           \
  }

#define MAT3DUTIL_MULT_V9_V9(C_, A_, B_)		\
 {							\
   C_ = A_[0]*B_[0] + A_[1]*B_[1] + A_[2]*B_[2] + A_[3]*B_[3] + A_[4]*B_[4] + A_[5]*B_[5] + A_[6]*B_[6] + A_[7]*B_[7] + A_[8]*B_[8];	\
}

/* C_ = A_ * B_ */
#define MAT3DUTIL_MULT_AB_3X3(C_, A_, B_)                                   \
 {                                                                          \
   C_[0][0]  = (A_[0][0]*B_[0][0] + A_[0][1]*B_[1][0] + A_[0][2]*B_[2][0]); \
   C_[0][1]  = (A_[0][0]*B_[0][1] + A_[0][1]*B_[1][1] + A_[0][2]*B_[2][1]); \
   C_[0][2]  = (A_[0][0]*B_[0][2] + A_[0][1]*B_[1][2] + A_[0][2]*B_[2][2]); \
   C_[1][0]  = (A_[1][0]*B_[0][0] + A_[1][1]*B_[1][0] + A_[1][2]*B_[2][0]); \
   C_[1][1]  = (A_[1][0]*B_[0][1] + A_[1][1]*B_[1][1] + A_[1][2]*B_[2][1]); \
   C_[1][2]  = (A_[1][0]*B_[0][2] + A_[1][1]*B_[1][2] + A_[1][2]*B_[2][2]); \
   C_[2][0]  = (A_[2][0]*B_[0][0] + A_[2][1]*B_[1][0] + A_[2][2]*B_[2][0]); \
   C_[2][1]  = (A_[2][0]*B_[0][1] + A_[2][1]*B_[1][1] + A_[2][2]*B_[2][1]); \
   C_[2][2]  = (A_[2][0]*B_[0][2] + A_[2][1]*B_[1][2] + A_[2][2]*B_[2][2]); \
 }

/* C_ = transp(A_) * B_ */
#define MAT3DUTIL_MULT_ATB_3X3(C_, A_, B_)                                  \
 {                                                                          \
   C_[0][0]  = (A_[0][0]*B_[0][0] + A_[1][0]*B_[1][0] + A_[2][0]*B_[2][0]); \
   C_[0][1]  = (A_[0][0]*B_[0][1] + A_[1][0]*B_[1][1] + A_[2][0]*B_[2][1]); \
   C_[0][2]  = (A_[0][0]*B_[0][2] + A_[1][0]*B_[1][2] + A_[2][0]*B_[2][2]); \
   C_[1][0]  = (A_[0][1]*B_[0][0] + A_[1][1]*B_[1][0] + A_[2][1]*B_[2][0]); \
   C_[1][1]  = (A_[0][1]*B_[0][1] + A_[1][1]*B_[1][1] + A_[2][1]*B_[2][1]); \
   C_[1][2]  = (A_[0][1]*B_[0][2] + A_[1][1]*B_[1][2] + A_[2][1]*B_[2][2]); \
   C_[2][0]  = (A_[0][2]*B_[0][0] + A_[1][2]*B_[1][0] + A_[2][2]*B_[2][0]); \
   C_[2][1]  = (A_[0][2]*B_[0][1] + A_[1][2]*B_[1][1] + A_[2][2]*B_[2][1]); \
   C_[2][2]  = (A_[0][2]*B_[0][2] + A_[1][2]*B_[1][2] + A_[2][2]*B_[2][2]); \
 }

/* C_ = A_ * transp(B_) */
#define MAT3DUTIL_MULT_ABT_3X3(C_, A_, B_)                                  \
 {                                                                          \
   C_[0][0]  = (A_[0][0]*B_[0][0] + A_[0][1]*B_[0][1] + A_[0][2]*B_[0][2]); \
   C_[0][1]  = (A_[0][0]*B_[1][0] + A_[0][1]*B_[1][1] + A_[0][2]*B_[1][2]); \
   C_[0][2]  = (A_[0][0]*B_[2][0] + A_[0][1]*B_[2][1] + A_[0][2]*B_[2][2]); \
   C_[1][0]  = (A_[1][0]*B_[0][0] + A_[1][1]*B_[0][1] + A_[1][2]*B_[0][2]); \
   C_[1][1]  = (A_[1][0]*B_[1][0] + A_[1][1]*B_[1][1] + A_[1][2]*B_[1][2]); \
   C_[1][2]  = (A_[1][0]*B_[2][0] + A_[1][1]*B_[2][1] + A_[1][2]*B_[2][2]); \
   C_[2][0]  = (A_[2][0]*B_[0][0] + A_[2][1]*B_[0][1] + A_[2][2]*B_[0][2]); \
   C_[2][1]  = (A_[2][0]*B_[1][0] + A_[2][1]*B_[1][1] + A_[2][2]*B_[1][2]); \
   C_[2][2]  = (A_[2][0]*B_[2][0] + A_[2][1]*B_[2][1] + A_[2][2]*B_[2][2]); \
 }

/* C_ = A_ + B_ */
#define MAT3DUTIL_ADD_AB_3X3(C_, A_, B_)        \
 {                                              \
   C_[0][0]  = A_[0][0] + B_[0][0];             \
   C_[0][1]  = A_[0][1] + B_[0][1];             \
   C_[0][2]  = A_[0][2] + B_[0][2];             \
   C_[1][0]  = A_[1][0] + B_[1][0];             \
   C_[1][1]  = A_[1][1] + B_[1][1];             \
   C_[1][2]  = A_[1][2] + B_[1][2];             \
   C_[2][0]  = A_[2][0] + B_[2][0];             \
   C_[2][1]  = A_[2][1] + B_[2][1];             \
   C_[2][2]  = A_[2][2] + B_[2][2];             \
 }

/* C_ = A_ + transp(B_) */
#define MAT3DUTIL_ADD_ABT_3X3(C_, A_, B_)        \
 {                                              \
   C_[0][0]  = A_[0][0] + B_[0][0];             \
   C_[0][1]  = A_[0][1] + B_[1][0];             \
   C_[0][2]  = A_[0][2] + B_[2][0];             \
   C_[1][0]  = A_[1][0] + B_[0][1];             \
   C_[1][1]  = A_[1][1] + B_[1][1];             \
   C_[1][2]  = A_[1][2] + B_[2][1];             \
   C_[2][0]  = A_[2][0] + B_[0][2];             \
   C_[2][1]  = A_[2][1] + B_[1][2];             \
   C_[2][2]  = A_[2][2] + B_[2][2];             \
 }
 
/* C_ = transp(A_) * B_ * A_ */
#define MAT3DUTIL_MULT_ATBA_3X3(C_, A_, B_)     \
 {                                              \
   double ATB_[3][3];                           \
   MAT3DUTIL_MULT_ATB_3X3 (ATB_, A_, B_);       \
   MAT3DUTIL_MULT_AB_3X3  (C_, ATB_, A_);       \
 }

/* C_ = A_ * B_ * transp(A_) */
#define MAT3DUTIL_MULT_ABAT_3X3(C_, A_, B_)     \
 {                                              \
   double AB_[3][3];                            \
   MAT3DUTIL_MULT_AB_3X3 (AB_, A_, B_);         \
   MAT3DUTIL_MULT_ABT_3X3  (C_, AB_, A_);       \
 }

/* C_ = alpha * A_ + beta * B_ */
#define MAT3DUTIL_COMB_AB_3X3(C_, alpha, A_, beta, B_)  \
 {                                                      \
   C_[0][0]  = alpha * A_[0][0] + beta * B_[0][0];      \
   C_[0][1]  = alpha * A_[0][1] + beta * B_[0][1];      \
   C_[0][2]  = alpha * A_[0][2] + beta * B_[0][2];      \
   C_[1][0]  = alpha * A_[1][0] + beta * B_[1][0];      \
   C_[1][1]  = alpha * A_[1][1] + beta * B_[1][1];      \
   C_[1][2]  = alpha * A_[1][2] + beta * B_[1][2];      \
   C_[2][0]  = alpha * A_[2][0] + beta * B_[2][0];      \
   C_[2][1]  = alpha * A_[2][1] + beta * B_[2][1];      \
   C_[2][2]  = alpha * A_[2][2] + beta * B_[2][2];      \
 }

/* C_ = alpha * A_^T + beta * B_ */
#define MAT3DUTIL_COMB_ATB_3X3(C_, alpha, A_, beta, B_)        \
 {                                                             \
   C_[0][0]  = alpha * A_[0][0] + beta * B_[0][0];             \
   C_[0][1]  = alpha * A_[1][0] + beta * B_[0][1];             \
   C_[0][2]  = alpha * A_[2][0] + beta * B_[0][2];             \
   C_[1][0]  = alpha * A_[0][1] + beta * B_[1][0];             \
   C_[1][1]  = alpha * A_[1][1] + beta * B_[1][1];             \
   C_[1][2]  = alpha * A_[2][1] + beta * B_[1][2];             \
   C_[2][0]  = alpha * A_[0][2] + beta * B_[2][0];             \
   C_[2][1]  = alpha * A_[1][2] + beta * B_[2][1];             \
   C_[2][2]  = alpha * A_[2][2] + beta * B_[2][2];             \
 }

/* A_ += B_ */
#define MAT3DUTIL_INCR_A_BY_B_3X3(A_, B_)       \
 {                                              \
   A_[0][0] += B_[0][0];                        \
   A_[0][1] += B_[0][1];                        \
   A_[0][2] += B_[0][2];                        \
   A_[1][0] += B_[1][0];                        \
   A_[1][1] += B_[1][1];                        \
   A_[1][2] += B_[1][2];                        \
   A_[2][0] += B_[2][0];                        \
   A_[2][1] += B_[2][1];                        \
   A_[2][2] += B_[2][2];                        \
 }

/* C_ = A_ - B_ */
#define MAT3DUTIL_SUB_AB_3X3(C_, A_, B_)        \
 {                                              \
   C_[0][0]  = A_[0][0] - B_[0][0];             \
   C_[0][1]  = A_[0][1] - B_[0][1];             \
   C_[0][2]  = A_[0][2] - B_[0][2];             \
   C_[1][0]  = A_[1][0] - B_[1][0];             \
   C_[1][1]  = A_[1][1] - B_[1][1];             \
   C_[1][2]  = A_[1][2] - B_[1][2];             \
   C_[2][0]  = A_[2][0] - B_[2][0];             \
   C_[2][1]  = A_[2][1] - B_[2][1];             \
   C_[2][2]  = A_[2][2] - B_[2][2];             \
 }

/* C_ = scalar * C_ */
#define MAT3DUTIL_SCALE_3X3(C_, scalar)         \
 {                                              \
   double _my_scalar_ = scalar;                 \
   C_[0][0]  *= _my_scalar_;                    \
   C_[0][1]  *= _my_scalar_;                    \
   C_[0][2]  *= _my_scalar_;                    \
   C_[1][0]  *= _my_scalar_;                    \
   C_[1][1]  *= _my_scalar_;                    \
   C_[1][2]  *= _my_scalar_;                    \
   C_[2][0]  *= _my_scalar_;                    \
   C_[2][1]  *= _my_scalar_;                    \
   C_[2][2]  *= _my_scalar_;                    \
 }

/* C_ = Tr( C_ ) */
#define MAT3DUTIL_TRACE_3X3(C_) (C_[0][0] + C_[1][1] + C_[2][2])

/* C_ = 0 */
#define MAT3DUTIL_ZERO_3X3(C_)                   \
 {                                               \
   C_[0][0]  = 0;                                \
   C_[0][1]  = 0;                                \
   C_[0][2]  = 0;                                \
   C_[1][0]  = 0;                                \
   C_[1][1]  = 0;                                \
   C_[1][2]  = 0;                                \
   C_[2][0]  = 0;                                \
   C_[2][1]  = 0;                                \
   C_[2][2]  = 0;                                \
 }

/* C_ = 1 */
#define MAT3DUTIL_UNIT_3X3(C_)                   \
 {                                               \
   C_[0][0]  = 1;                                \
   C_[0][1]  = 0;                                \
   C_[0][2]  = 0;                                \
   C_[1][0]  = 0;                                \
   C_[1][1]  = 1;                                \
   C_[1][2]  = 0;                                \
   C_[2][0]  = 0;                                \
   C_[2][1]  = 0;                                \
   C_[2][2]  = 1;                                \
 }


/* C_ = 1 */
#define MAT3DUTIL_UNIT_6X6(C_)                   \
 {                                               \
   C_[0][0]  = 1;                                \
   C_[0][1]  = 0;                                \
   C_[0][2]  = 0;                                \
   C_[0][3]  = 0;                                \
   C_[0][4]  = 0;                                \
   C_[0][5]  = 0;                                \
   C_[1][0]  = 0;                                \
   C_[1][1]  = 1;                                \
   C_[1][2]  = 0;                                \
   C_[1][3]  = 0;                                \
   C_[1][4]  = 0;                                \
   C_[1][5]  = 0;                                \
   C_[2][0]  = 0;                                \
   C_[2][1]  = 0;                                \
   C_[2][2]  = 1;                                \
   C_[2][3]  = 0;                                \
   C_[2][4]  = 0;                                \
   C_[2][5]  = 0;                                \
   C_[3][0]  = 0;                                \
   C_[3][1]  = 0;                                \
   C_[3][2]  = 0;                                \
   C_[3][3]  = 1;                                \
   C_[3][4]  = 0;                                \
   C_[3][5]  = 0;                                \
   C_[4][0]  = 0;                                \
   C_[4][1]  = 0;                                \
   C_[4][2]  = 0;                                \
   C_[4][3]  = 0;                                \
   C_[4][4]  = 1;                                \
   C_[4][5]  = 0;                                \
   C_[5][0]  = 0;                                \
   C_[5][1]  = 0;                                \
   C_[5][2]  = 0;                                \
   C_[5][3]  = 0;                                \
   C_[5][4]  = 0;                                \
   C_[5][5]  = 1;                                \
 }


/* sum_i,j A_ij * B_ij */
#define MAT3DUTIL_DBL_PROD_3X3(A_, B_) (  A_[0][0] * B_[0][0]        \
                                        + A_[0][1] * B_[0][1]        \
                                        + A_[0][2] * B_[0][2]        \
                                        + A_[1][0] * B_[1][0]        \
                                        + A_[1][1] * B_[1][1]        \
                                        + A_[1][2] * B_[1][2]        \
                                        + A_[2][0] * B_[2][0]        \
                                        + A_[2][1] * B_[2][1]        \
                                        + A_[2][2] * B_[2][2])

#define MAT3DUTIL_INVERT_3X3(det_J, J, inv_J)                           \
  {                                                                     \
    double det_J_inv = 1 / det_J;                                       \
                                                                        \
    inv_J[0][0] =   det_J_inv * (J[1][1]*J[2][2] - J[1][2]*J[2][1]);    \
    inv_J[0][1] = - det_J_inv * (J[0][1]*J[2][2] - J[0][2]*J[2][1]);    \
    inv_J[0][2] =   det_J_inv * (J[0][1]*J[1][2] - J[0][2]*J[1][1]);    \
                                                                        \
    inv_J[1][0] = - det_J_inv * (J[1][0]*J[2][2] - J[1][2]*J[2][0]);    \
    inv_J[1][1] =   det_J_inv * (J[0][0]*J[2][2] - J[0][2]*J[2][0]);    \
    inv_J[1][2] = - det_J_inv * (J[0][0]*J[1][2] - J[0][2]*J[1][0]);    \
                                                                        \
    inv_J[2][0] =   det_J_inv * (J[1][0]*J[2][1] - J[1][1]*J[2][0]);    \
    inv_J[2][1] = - det_J_inv * (J[0][0]*J[2][1] - J[0][1]*J[2][0]);    \
    inv_J[2][2] =   det_J_inv * (J[0][0]*J[1][1] - J[0][1]*J[1][0]);    \
  }

#define MAT3DUTIL_COFACTOR_3X3(J, J_cof)                    \
  {                                                         \
    J_cof[0][0] =   (J[1][1]*J[2][2] - J[1][2]*J[2][1]);    \
    J_cof[0][1] = - (J[0][1]*J[2][2] - J[0][2]*J[2][1]);    \
    J_cof[0][2] =   (J[0][1]*J[1][2] - J[0][2]*J[1][1]);    \
                                                            \
    J_cof[1][0] = - (J[1][0]*J[2][2] - J[1][2]*J[2][0]);    \
    J_cof[1][1] =   (J[0][0]*J[2][2] - J[0][2]*J[2][0]);    \
    J_cof[1][2] = - (J[0][0]*J[1][2] - J[0][2]*J[1][0]);    \
                                                            \
    J_cof[2][0] =   (J[1][0]*J[2][1] - J[1][1]*J[2][0]);    \
    J_cof[2][1] = - (J[0][0]*J[2][1] - J[0][1]*J[2][0]);    \
    J_cof[2][2] =   (J[0][0]*J[1][1] - J[0][1]*J[1][0]);    \
  }

/* Convert a vector of 6 components into a
   symmetric second-order tensor (3x3 matrix).
   The ordering of components is as used in bmat.c */
#define MAT3DUTIL_V_TO_T(V_, T_)                \
  {                                             \
    T_[0][0] = V_[0];                           \
    T_[1][1] = V_[1];                           \
    T_[2][2] = V_[2];                           \
    T_[0][1] = T_[1][0] = V_[3];                \
    T_[0][2] = T_[2][0] = V_[4];                \
    T_[1][2] = T_[2][1] = V_[5];                \
  }

/* Convert a symmetric second-order tensor (3x3 matrix) to a vector form
   The ordering of components is as used in bmat.c
 */
#define MAT3DUTIL_T_TO_V(T_, V_)                \
  {                                             \
    V_[0] = T_[0][0];                           \
    V_[1] = T_[1][1];                           \
    V_[2] = T_[2][2];                           \
    V_[3] = T_[0][1];                           \
    V_[4] = T_[0][2];                           \
    V_[5] = T_[1][2];                           \
  }

#define MAT3DUTIL_T_TO_V9(T_, V_)		\
  {						\
    V_[0] = T_[0][0];                           \
    V_[1] = T_[1][1];                           \
    V_[2] = T_[2][2];                           \
    V_[3] = T_[0][1];                           \
    V_[4] = T_[0][2];                           \
    V_[5] = T_[1][2];                           \
    V_[6] = T_[1][0];                           \
    V_[7] = T_[2][0];                           \
    V_[8] = T_[2][1];                           \
  }
/* Convert a symmetric second-order tensor (3x3) to a vector form
   V_[3]~V_[5] are 2 times of the non-diagonal components of T_
   The ordering of components is as used in bmat.c
*/
#define MAT3DUTIL_T_TO_V1(T_, V_)                \
  {                                             \
    V_[0] =   T_[0][0];                           \
    V_[1] =   T_[1][1];                           \
    V_[2] =   T_[2][2];                           \
    V_[3] = 2*T_[1][0];                           \
    V_[4] = 2*T_[0][2];                           \
    V_[5] = 2*T_[2][1];                           \
  } 

#define MAT3DUTIL_SYMM(DEST_, SRC_)                                     \
  {                                                                     \
    DEST_[0][0] = SRC_[0][0];                                           \
    DEST_[1][1] = SRC_[1][1];                                           \
    DEST_[2][2] = SRC_[2][2];                                           \
    DEST_[0][1] = DEST_[1][0] = 0.5 * (SRC_[0][1] + SRC_[1][0]);        \
    DEST_[0][2] = DEST_[2][0] = 0.5 * (SRC_[0][2] + SRC_[2][0]);        \
    DEST_[2][1] = DEST_[1][2] = 0.5 * (SRC_[2][1] + SRC_[1][2]);        \
  }
#define MAT3DUTIL_ASYMM(DEST_, SRC_)                                    \
  {                                                                     \
    DEST_[0][0] = 0;                                                    \
    DEST_[1][1] = 0;                                                    \
    DEST_[2][2] = 0;                                                    \
    DEST_[0][1] = 0.5 * (SRC_[0][1] - SRC_[1][0]);        \
    DEST_[0][2] = 0.5 * (SRC_[0][2] - SRC_[2][0]);        \
    DEST_[2][1] = 0.5 * (SRC_[2][1] - SRC_[1][2]);        \
    DEST_[1][0] = -DEST_[0][1];                                         \
    DEST_[2][0] = -DEST_[0][2];                                         \
    DEST_[1][2] = -DEST_[2][1];                                         \
  }

#define MAT3DUTIL_2_V(V1_, op, V2_)             \
  {                                             \
    V1_[0] op V2_[0];                           \
    V1_[1] op V2_[1];                           \
    V1_[2] op V2_[2];                           \
    V1_[3] op V2_[3];                           \
    V1_[4] op V2_[4];                           \
    V1_[5] op V2_[5];                           \
  }

/* Compute the product S=C*E, where
   S[0..5] = stress vector,
   E[0..5] = strain vector,
   C[0..5][0..5] = constitutive matrix
*/
#define MAT3DUTIL_S_C_E(S,C,E)                                          \
  {                                                                     \
    double Sv__;                                                        \
    int i__;                                                            \
    for (i__ = 0; i__ < 6; i__++) {                                     \
      Sv__ = 0;                                                         \
      {                                                                 \
        int j__;                                                        \
        for (j__ = 0; j__ < 6; j__++) {Sv__ += C[i__][j__] * E[j__];}   \
        S[i__] = Sv__;                                                  \
      }                                                                 \
    }                                                                   \
  }

/* Define a matrix as the tensor product of two vectors */
#define MAT3DUTIL_TENS_PROD_V(A, V1, V2)                                \
   A[0][0] = V1[0]*V2[0]; A[0][1] = V1[0]*V2[1]; A[0][2] = V1[0]*V2[2]; \
   A[1][0] = V1[1]*V2[0]; A[1][1] = V1[1]*V2[1]; A[1][2] = V1[1]*V2[2]; \
   A[2][0] = V1[2]*V2[0]; A[2][1] = V1[2]*V2[1]; A[2][2] = V1[2]*V2[2];


#define MAT3DUTIL_TENS_PROD_V9(A, V1, V2)	\
  {						\
    int i__, j__;				\
    for (i__ = 0; i__ < 9; i__++) {		\
       for (j__ = 0; j__ < 9; j__++) {		\
       A[i__][j__] = V1[i__] * V2[j__];		\
       }					\
    }						\
  }

#define MAT3DUTIL_DOT_V(V1,V2) (V1[0]*V2[0]+V1[1]*V2[1]+V1[2]*V2[2])
#define MAT3DUTIL_DOT_V6(V1,V2) (V1[0]*V2[0]+V1[1]*V2[1]+V1[2]*V2[2]    \
                             +2*(V1[3]*V2[3]+V1[4]*V2[4]+V1[5]*V2[5]))

W_bool_t
W_mat3dutil_invert_3x3(double J[3][3], double inv_J[3][3]);


#endif /* WMAT3DUTIL_H */
