#ifndef WMATS_H
#   define WMATS_H

#include "Wtypes.h"
#include "Wutil.h"

W_bool_t
W_material_reader(W_domain_t *d);

W_bool_t
WM_get_uniax_lin_el_consts(W_material_t *m,
                           W_float_t *E,
                           W_float_t *nu
                           );

W_float_t
WM_get_volume_mass(W_material_t *m);

W_matstate_t 
WM_get_mat_state(W_material_t *m);

W_bool_t
WM_get_uniax_stress(W_material_t *m,
                    W_matstate_t ms,
                    W_float_t strain,
                    W_float_t strain_rate,
                    W_float_t *stress
                    );

W_bool_t
WM_get_pss_stress(W_material_t *m,
                      W_matstate_t ms,
                      W_float_t eps1, W_float_t eps2, W_float_t gamma,
                      W_float_t eps1_rate,
                      W_float_t eps2_rate,
                      W_float_t gamma_rate,
                      W_float_t *sigma1,  W_float_t *sigma2,
                      W_float_t *tau
                      );
W_float_t
WM_get_uniax_def_energy(W_material_t *m, W_matstate_t ms, W_float_t strain);

W_float_t
WM_get_pss_def_energy(W_material_t *m, W_matstate_t ms,
                      W_float_t eps1, W_float_t eps2, W_float_t gamma);

W_bool_t
WM_is_in_plastic_state(W_material_t *m,
                       W_matstate_t ms);

W_bool_t 
WM_get_3d_stress(W_material_t *m, W_matstate_t ms,
                 W_float_t eps[6], W_float_t eps_rate[6], W_float_t sigma[6]);

W_float_t 
WM_get_3d_def_energy(W_material_t *m, W_matstate_t ms, W_float_t eps[6]);

/*
   Create a new material.
 */
W_material_t * /* new material */
WM_new_material (W_mcode_t mcode, /* material code */
                 int id,
                 W_material_methods_t *methods, /* type-specific methods */
                 void *data, /* type-specific data */
                 double rho /* volume mass */
                 );

#ifdef X_XFACE
EPixel
WM_get_color(W_material_t *m);
EFringeTable
WM_get_fringe_table(W_material_t *m);
#endif

int
WM_get_id (W_material_t *m);

#endif /* !WMATS_H */
