#ifndef W_MODRC_H
#define W_MODRC_H

typedef struct W_modr_collector_t *W_modr_collector_p;

typedef void (*W_modr_get_node_data_proc) (void *client, W_node_t *n, double *x, double *y, double *z);

W_modr_collector_p
W_modr_collector_new (W_domain_t *d);

void
W_modr_collector_accumulate (W_modr_collector_p modr);

void
W_modr_collector_compute_modes (W_modr_collector_p modr);

#ifdef X_XFACE
void
W_modr_collector_show_mode (W_modr_collector_p modr, int mode);
#endif

double
W_modr_collector_eigenvalue (W_modr_collector_p modr, int mode);

int
W_modr_collector_tot_modes (W_modr_collector_p modr);

int
W_modr_collector_write_mean (W_modr_collector_p modr, FILE *fp);

int
W_modr_collector_write_mode (W_modr_collector_p modr, int mode, FILE *fp);

int
W_modr_collector_save_data (W_modr_collector_p modr, FILE *fp) ;

int
W_modr_collector_write_modr (W_modr_collector_p modr, FILE *fp);

double
W_modr_collector_set_dt (W_modr_collector_p modr, double dt);

double
W_modr_collector_set_from_t (W_modr_collector_p modr, double from_t);

double
W_modr_collector_set_up_to_t (W_modr_collector_p modr, double up_to_t);

double
W_modr_collector_set_cutoff_ev (W_modr_collector_p modr, double cutoff_ev);

W_bool_t
W_modr_collector_set_dont_subtract_mean (W_modr_collector_p modr, W_bool_t dont_subtract_mean);

W_modr_method_t 
W_modr_collector_set_method (W_modr_collector_p modr, W_modr_method_t method);

double
W_modr_collector_get_dt (W_modr_collector_p modr);

void
W_modr_collector_accumulate_with (W_modr_collector_p modr, void *client,
                                 W_modr_get_node_data_proc get_node_data);

#endif
