#ifndef W_MODRR_H
#define W_MODRR_H

typedef enum W_modr_method_t { MODR_DIRECT = 0, MODR_SNAPSHOTS = 1 } W_modr_method_t;

W_bool_t 
W_modr_reader (W_domain_t *d);

void
W_modr_accumulate (W_modr_p modr);

void
W_modr_compute_modes (W_modr_p modr);

void
W_modr_show_mode (W_modr_p modr, int mode);

double
W_modr_eigenvalue (W_modr_p modr, int mode);

int
W_modr_tot_modes (W_modr_p modr);

int
W_modr_write_mode (W_modr_p modr, int mode, FILE *fp);

int
W_modr_write_mean (W_modr_p modr, FILE *fp);

void
W_modr_dof_modes (W_modr_p modr, W_index_t dof, double *v, double *mean);

int
W_modr_get_nmodes (W_modr_p modr);

int
W_modr_is_in_collect_mode (W_modr_p modr);

int
W_modr_is_in_use_mode (W_modr_p modr);

double
W_modr_init_value (W_modr_p modr, int mode);

int
W_modr_save_collected_data (W_modr_p modr, FILE *fp);

int
W_modr_write_modr (W_modr_p modr, FILE *fp);

int
W_modr_revert_to_orig_modes (W_modr_p modr);

int
W_modr_include_mode (W_modr_p modr, int to_replace, double *data);

int
W_modr_should_save_data (W_modr_p modr);

#endif
