#ifndef WMPI_H
#   define WMPI_H

#if defined (MPI_WASP) && MPI_WASP

#include "mpi.h"

#define W_MPI_ACCEL_EXCHANGE_TAG 1303

W_bool_t
W_mpi_run_reader (W_domain_t *d, FILE *stream);

/*
  Build communication buffers.
  Build communication buffers by either exchanging information with
  all the peers, or by scanning the input data.
 */
void
W_mpi_build_comm_buffs (W_mpi_process_t *p);

void
W_mpi_exchange (W_domain_t *d         /* IN: domain */,
                int n,
                W_mpi_pack_func pack, /* IN: pack function */
                W_mpi_unpack_func unpack, /* IN: unpack function */
                int tag               /* IN: message tag */
                );

void
W_mpi_realloc_sbuf (W_mpi_comm_buff_t *comm_buff);

void
W_mpi_realloc_rbuf (W_mpi_comm_buff_t *comm_buff);

void
W_mpi_exchange_accels (W_domain_t *d /* domain */);

void
W_mpi_exchange_forces (W_domain_t *d /* domain */);

void
W_mpi_exchange_masses (W_domain_t *d /* domain */);

#endif /* defined (MPI_WASP) && MPI_WASP  */

#endif
