#ifndef WNEWMMODR_H
#   define WNEWMMODR_H

/*
   New model-reduction Newmark integrator.
   Create a new  Newmark integrator implementation.
   It uses model reduction.
 */
struct W_newmark_integrator_t *
W_newmark_new_modr_integrator (W_newmark_client_t     client, /* client (may be, but needn't be, the domain) */
                               W_domain_t               *domain, /* domain */
                               W_float_t               t0, /* initial time */
                               W_float_t               dt, /* time step */
                               W_float_t               beta, /* Newmark beta */
                               W_float_t               gamma, /* Newmark gamma */
                               fles_tot_of_equations_callback
                               tot_of_equations_callback, /* total-of-equations callback; this function is defined
                                                             on the client of the implementation */
                               W_newmark_assemble_eff_stiff_client_proc
                               assemble_eff_stiff, /* procedure to assemble
                                                      effective stiffness */
                               W_newmark_assemble_residual_force_client_proc
                               residual_force, /* procedure to assemble
                                                  residual force */
                               W_newmark_start_step_client_proc
                               start_step, /* procedure to start a new step */
                               W_newmark_update_config_client_proc
                               update_config, /* procedure to update configuration */
                               W_newmark_finalize_step_client_proc
                               finalize_step, /* procedure to finalize step */
                               char *optstring /* options string; specify option+value pairs */
                               );

#endif 
