#ifndef WOPTIONS_H
#define WOPTIONS_H

#define WOPT_ACCESS_VALUE_FUNC_NAME(optname) WO_get_##optname
#define WOPT_SET_VALUE_FUNC_NAME(optname) WO_set_##optname
#define WOPT_DCL_ACCESS_OPT_VALUE_FUNC(o, type, optname) \
        type WOPT_ACCESS_VALUE_FUNC_NAME (optname) (struct W_options_t *o)
#define WOPT_DCL_SET_OPT_VALUE_FUNC(o, type, optname) \
        void WOPT_SET_VALUE_FUNC_NAME (optname) (struct W_options_t *o, type arg)

#define WOPT_OPT(o, optname) WOPT_ACCESS_VALUE_FUNC_NAME (optname) (o)
#define WOPT_SET_OPT(o, optname, value) WOPT_SET_VALUE_FUNC_NAME (optname) (o, value)

#define WOPT_LIST                                                                               \
WOPT_LIST_ITEM (o, int                        , argc, 0);                                       \
WOPT_LIST_ITEM (o, char                     **, argv, NULL);                                    \
WOPT_LIST_ITEM (o, int                       *, argcp, NULL);                                   \
WOPT_LIST_ITEM (o, char                    ***, argvp, NULL);                                   \
WOPT_LIST_ITEM (o, W_bool_t                   , help, FALSE);                                   \
WOPT_LIST_ITEM (o, W_bool_t                   , report_opts, FALSE);                            \
WOPT_LIST_ITEM (o, char                      *, in_file_name, NULL);                            \
WOPT_LIST_ITEM (o, char                      *, in_file_basename, NULL);                        \
WOPT_LIST_ITEM (o, char                      *, hist_file_name, NULL);                          \
WOPT_LIST_ITEM (o, char                      *, error_log_name, NULL);                          \
WOPT_LIST_ITEM (o, char                      *, log_name, NULL);                                \
WOPT_LIST_ITEM (o, char                      *, out_file_name, NULL);                           \
WOPT_LIST_ITEM (o, W_bool_t                   , verbose, FALSE);                                \
WOPT_LIST_ITEM (o, W_bool_t                   , no_output, TRUE);                               \
WOPT_LIST_ITEM (o, W_task_type_t              , task_type, TASK_3D);                            \
WOPT_LIST_ITEM (o, int                        , integrator, CD_INTEGRATOR);                     \
WOPT_LIST_ITEM (o, int                        , integrator_detail, 0);                          \
WOPT_LIST_ITEM (o, W_bool_t                   , X_xface, FALSE);                                \
WOPT_LIST_ITEM (o, W_float_t                  , triad_leg_length, 1);                           \
WOPT_LIST_ITEM (o, W_bool_t                   , track_nodes, FALSE);                            \
WOPT_LIST_ITEM (o, W_float_t                  , displ_scale, 1);                                \
WOPT_LIST_ITEM (o, W_float_t                  , force_scale, 1);                                \
WOPT_LIST_ITEM (o, W_bool_t                   , draw_numbers, FALSE);                           \
WOPT_LIST_ITEM (o, char                      *, elixir_cmd_file, NULL);                         \
WOPT_LIST_ITEM (o, W_float_t                  , target_time, 1);                                \
WOPT_LIST_ITEM (o, W_float_t                  , time_step, 0);                                  \
WOPT_LIST_ITEM (o, W_float_t                  , time_between_outputs, 0);                       \
WOPT_LIST_ITEM (o, W_bool_t                   , color_encoded_forces, FALSE);                   \
WOPT_LIST_ITEM (o, W_bool_t                   , careless, FALSE);                               \
WOPT_LIST_ITEM (o, W_bool_t                   , interactive_during_outputs, FALSE);             \
WOPT_LIST_ITEM (o, W_bool_t                   , debug_pvm, FALSE);                              \
WOPT_LIST_ITEM (o, W_bool_t                   , serial, FALSE);                                 \
WOPT_LIST_ITEM (o, double                     , time_step_reduction, 1);                        \
WOPT_LIST_ITEM (o, int                        , time_step_reduction_func, 0);                   \
WOPT_LIST_ITEM (o, W_bool_t                   , running_patch_test, FALSE);                     \
WOPT_LIST_ITEM (o, int                        , postfile_type, HEXVUE_POSTPROC_FILE);           \
WOPT_LIST_ITEM (o, char                      *, hexvue_format, "compressed");                   \
WOPT_LIST_ITEM (o, char                      *, expeval_init, NULL);                            \
WOPT_LIST_ITEM (o, int                        , postfile_output_spec_deprec, W_POSTFILE_DISPL_MASK);   \
WOPT_LIST_ITEM (o, char                      *, postfile_output_specs, NULL);                   \
WOPT_LIST_ITEM (o, W_postfile_output_specs_t  , postfile_output_specs_list, default_specs_list);\
WOPT_LIST_ITEM (o, char                      *, postfile_times, NULL);                          \
WOPT_LIST_ITEM (o, W_postfile_times_list_t    , postfile_times_list, default_times_list);       \
WOPT_LIST_ITEM (o, W_bool_t                   , postfile_number_seq, FALSE);                    \
WOPT_LIST_ITEM (o, W_bool_t                   , postfile_user_labels, FALSE);                   \
WOPT_LIST_ITEM (o, W_bool_t                   , write_postfile_file_now, FALSE);                \
WOPT_LIST_ITEM (o, int                        , optimization_level, 0);                         \
WOPT_LIST_ITEM (o, int                        , hist_buff_length, MAXHISTBUFFLNGTH);            \
WOPT_LIST_ITEM (o, W_output_stress_type_enum  , output_stress_type, W_OUTPUT_STRESS_CAUCHY);    \
WOPT_LIST_ITEM (o, W_q_func_enum              , q_func_type, W_COMPOSITE_QUADRATIC_Q_FUNC);     \
WOPT_LIST_ITEM (o, W_j_dom_eval_enum          , j_dom_eval, W_PER_CELL_IPOL_PTS);               \
WOPT_LIST_ITEM (o, W_sifs_eval_from_enum      , sifs_from, W_SIFS_FROM_II_INTEGRAL);            \
WOPT_LIST_ITEM (o, double                     , rayleigh_mass_damping_coeff, 0);                \
WOPT_LIST_ITEM (o, int                        , mass_damping_time_func, 0);                     \
WOPT_LIST_ITEM (o, W_mass_type_enum           , mass_type, W_MASS_CONSISTENT);                  \
WOPT_LIST_ITEM (o, char                      *, modr_options, NULL);                            \
WOPT_LIST_ITEM (o, char                      *, newmarki_options, NULL);                        \
WOPT_LIST_ITEM (o, char                      *, cdi_options, NULL);                             \
WOPT_LIST_ITEM (o, char                      *, hexvue_xtra_opts, NULL);                        \
WOPT_LIST_ITEM (o, W_bool_t                   , gather_frames, FALSE);                          \
WOPT_LIST_ITEM (o, double                     , frame_dt, 0);                                   \
WOPT_LIST_ITEM (o, char                      *, frame_format, "tiff");


typedef struct W_options_t {
  /* these fields are private */
  int cl_options_found_table_dim;
  char **cl_options_found;
  int cl_options_found_idx;
  /* these fields can be accessed as options */
#define WOPT_FIELD(type, optname) type optname
#undef WOPT_LIST_ITEM
#define WOPT_LIST_ITEM(o,type,optname,value) WOPT_FIELD(type,optname)
WOPT_LIST
}              W_options_t; 


#undef WOPT_LIST_ITEM
#define WOPT_LIST_ITEM(o,type,optname,value) WOPT_DCL_ACCESS_OPT_VALUE_FUNC (o, type, optname)
WOPT_LIST

#undef WOPT_LIST_ITEM
#define WOPT_LIST_ITEM(o,type,optname,value) WOPT_DCL_SET_OPT_VALUE_FUNC (o, type, optname)
WOPT_LIST

W_bool_t 
W_options_reader (W_domain_t *d);

struct W_options_t *
WO_new_options (void);

W_bool_t
WO_get_options (struct W_options_t *o, int argc, char **argv) ;


#endif
