#ifndef WPSS_H
#   define WPSS_H

#include "Wtypes.h"
#include "Wutil.h"

void
jacobian_matrix_2d(W_float_t J[2][2], W_float_t eta, W_float_t xi,
                   W_coords_3d_t *node1, W_coords_3d_t *node2,
                   W_coords_3d_t *node3, W_coords_3d_t *node4
                   );

void
pss_compute_N_matrix(W_float_t n[2][8],
                 W_float_t eta, W_float_t xi);

void
pss_N_matrix(W_float_t n[4], W_float_t eta, W_float_t xi);

void
pss_compute_N_xi_matrix(W_float_t n_xi[4], W_float_t eta, W_float_t xi);

void
pss_compute_N_eta_matrix(W_float_t n_eta[4], W_float_t eta, W_float_t xi);


void
pss_compute_B_matrix(W_float_t b[3][8],
                     W_float_t eta, W_float_t xi,
                     W_float_t inv_jacobian[2][2],
                     W_float_t inv_jacobian_at_0_0[2][2]);

void
pss_jacobian_matrix(W_float_t J[2][2], W_float_t eta, W_float_t xi,
                    W_float_t x1, W_float_t y1, 
                    W_float_t x2, W_float_t y2,
                    W_float_t x3, W_float_t y3,
                    W_float_t x4, W_float_t y4
                    ) ;

W_float_t
pss_jacobian(W_float_t J[2][2]);

void
pss_invert_jacobian_matrix(W_float_t J[2][2], W_float_t inv_J[2][2]);

#endif /* !WPSS_H */
