#! /bin/ksh

plast=true

function delta {
    I=$1; shift
    J=$1; 
    if [ $I -eq $J ] ; then echo 1;
    else                    echo 0;
    fi
}

function Cep {
    i=$1; shift
    j=$1; shift
    k=$1; shift
    l=$1; shift

    if [ $(expeval "$(delta $i $j)*$(delta $k $l)")  -ne 0 ] ; then Kexpr="K";
    else                                                            Kexpr="";
    fi
    GBv=$(expeval "1/2*($(delta $i $k)*$(delta $j $l) + $(delta $i $l)*$(delta $j $k)) - 1/3*$(delta $i $j)*$(delta $k $l)")
    if [ $(expeval "ne ($GBv, 0)") -ne 0 ] ; then
        if [ $plast = true ] ; then
            GBexpr="+2*G*B*($GBv)";
        else
            GBexpr="+2*G*($GBv)";
        fi
    else                                          GBexpr="";
    fi
    if [ $plast = true ] ; then
        Ggexpr="- 2*G*gammabar*N$(($i-1))$(($j-1))*N$(($k-1))$(($l-1))"
    else
        Ggexpr="- 0"
    fi        
    echo "$Kexpr $GBexpr $Ggexpr"
}

echo "C_mat[0][0] = $(Cep 1 1 1 1);"
echo "C_mat[0][1] = C_mat[1][0] = $(Cep 1 1 2 2);"
echo "C_mat[0][2] = C_mat[2][0] = $(Cep 1 1 3 3);"
echo "C_mat[0][3] = C_mat[3][0] = (($(Cep 1 1 1 2)) + ($(Cep 1 1 2 1)))/2;"
echo "C_mat[0][4] = C_mat[4][0] = (($(Cep 1 1 1 3)) + ($(Cep 1 1 3 1)))/2;"
echo "C_mat[0][5] = C_mat[5][0] = (($(Cep 1 1 2 3)) + ($(Cep 1 1 3 2)))/2;"

echo "C_mat[1][1] = $(Cep 2 2 2 2);"
echo "C_mat[1][2] = C_mat[2][1] = $(Cep 2 2 3 3);"
echo "C_mat[1][3] = C_mat[3][1] = (($(Cep 2 2 1 2)) + ($(Cep 2 2 2 1)))/2;"
echo "C_mat[1][4] = C_mat[4][1] = (($(Cep 2 2 1 3)) + ($(Cep 2 2 3 1)))/2;"
echo "C_mat[1][5] = C_mat[5][1] = (($(Cep 2 2 2 3)) + ($(Cep 2 2 3 2)))/2;"

echo "C_mat[2][2] = $(Cep 3 3 3 3);"
echo "C_mat[2][3] = C_mat[3][2] = (($(Cep 3 3 1 2)) + ($(Cep 3 3 2 1)))/2;"
echo "C_mat[2][4] = C_mat[4][2] = (($(Cep 3 3 1 3)) + ($(Cep 3 3 3 1)))/2;"
echo "C_mat[2][5] = C_mat[5][2] = (($(Cep 3 3 2 3)) + ($(Cep 3 3 3 2)))/2;"

echo "C_mat[3][3] = (($(Cep 1 2 1 2)) + ($(Cep 1 2 2 1)))/2;"
echo "C_mat[3][4] = C_mat[4][3] = (($(Cep 1 2 1 3)) + ($(Cep 1 2 3 1)))/2;"
echo "C_mat[3][5] = C_mat[5][3] = (($(Cep 1 2 2 3)) + ($(Cep 1 2 3 2)))/2;"

echo "C_mat[4][4] = (($(Cep 1 3 1 3)) + ($(Cep 1 3 3 1)))/2;"
echo "C_mat[4][5] = C_mat[5][4] = (($(Cep 1 3 2 3)) + ($(Cep 1 3 3 2)))/2;"

echo "C_mat[5][5] = (($(Cep 2 3 2 3)) + ($(Cep 2 3 3 2)))/2;"
