
/* RCSHEADER "$Id: consttransf.c,v 1.1.1.1 2001/07/24 02:42:51 pkrysl Exp $" */

static void
T_from_R (double T[6][6],       /* OUT: transformation (rotation) matrix */
          double R[3][3]        /* IN: rotation tensor */
          )
{
#define TROW(j, t0, t1, t2, t3, t4, t5) \
 { T[j-1][0] = t0; T[j-1][1] = t1; T[j-1][2] = t2; T[j-1][3] = t3; T[j-1][4] = t4; T[j-1][5] = t5; }
#define r(i,j) R[i-1][j-1]
#define sq(t) (t)*(t)
  TROW (1, sq(r(1,1)), sq(r(1,2)), sq(r(1,3)), 2*r(1,1)*r(1,2), 2*r(1,3)*r(1,2), 2*r(1,1)*r(1,3));
  TROW (2, sq(r(2,1)), sq(r(2,2)), sq(r(2,3)), 2*r(2,1)*r(2,2), 2*r(2,3)*r(2,2), 2*r(2,1)*r(2,3));
  TROW (3, sq(r(3,1)), sq(r(3,2)), sq(r(3,3)), 2*r(3,1)*r(3,2), 2*r(3,3)*r(3,2), 2*r(3,1)*r(3,3));
  TROW (4, r(1,1)*r(2,1), r(1,2)*r(2,2), r(1,3)*r(2,3),
        (r(1,1)*r(2,2)+r(2,1)*r(1,2)), (r(1,2)*r(2,3)+r(1,3)*r(2,2)), (r(1,1)*r(2,3)+r(1,3)*r(2,1)));
  TROW (5, r(2,1)*r(3,1), r(3,2)*r(2,2), r(2,3)*r(3,3),
        (r(2,1)*r(3,2)+r(2,2)*r(3,1)), (r(2,2)*r(3,3)+r(3,2)*r(2,3)), (r(2,1)*r(3,3)+r(2,3)*r(3,1)));
  TROW (6, r(1,1)*r(3,1), r(1,2)*r(3,2), r(1,3)*r(3,3),
        (r(1,1)*r(3,2)+r(1,2)*r(3,1)), (r(1,2)*r(3,3)+r(1,3)*r(3,2)), (r(1,1)*r(3,3)+r(3,1)*r(1,3)));
}
