#! /bin/ksh

function delta {
    I=$1; shift
    J=$1; 
    if [ $I -eq $J ] ; then echo 1;
    else                    echo 0;
    fi
}

function I {
    i=$1; shift
    j=$1; shift
    k=$1; shift
    l=$1; shift
    echo $(expeval "($(delta $i $k)*$(delta $j $l) + $(delta $i $l)*$(delta $j $k)) / 2")
}

function A {
    i=$1; shift
    j=$1; shift
    k=$1; shift
    l=$1; shift
    echo "(a_$i*a_$j*a_$k*a_$l + b_$i*b_$j*b_$k*b_$l + c_$i*c_$j*c_$k*c_$l)"
}

function C {
    i=$1; shift
    j=$1; shift
    k=$1; shift
    l=$1; shift

    if [ $(expeval "$(delta $i $j)*$(delta $k $l)")  -ne 0 ] ; then expr1="c12 + ";
    else                                                            expr1="";
    fi
    if [ $(expeval "ne($(I $i $j $k $l),0)") -ne 0 ] ; then expr2="2*c44*($(I $i $j $k $l)) +";
    else                                                    expr2="";
    fi
    echo "$expr1 $expr2 (c11 - c12 - 2*c44) * ($(A $i $j $k $l))"
}

echo "C_mat[0][0] = $(C 1 1 1 1);"
echo "C_mat[0][1] = C_mat[1][0] = $(C 1 1 2 2);"
echo "C_mat[0][2] = C_mat[2][0] = $(C 1 1 3 3);"
echo "C_mat[0][3] = C_mat[3][0] = (($(C 1 1 1 2)) + ($(C 1 1 2 1)))/2;"
echo "C_mat[0][4] = C_mat[4][0] = (($(C 1 1 1 3)) + ($(C 1 1 3 1)))/2;"
echo "C_mat[0][5] = C_mat[5][0] = (($(C 1 1 2 3)) + ($(C 1 1 3 2)))/2;"

echo "C_mat[1][1] = $(C 2 2 2 2);"
echo "C_mat[1][2] = C_mat[2][1] = $(C 2 2 3 3);"
echo "C_mat[1][3] = C_mat[3][1] = (($(C 2 2 1 2)) + ($(C 2 2 2 1)))/2;"
echo "C_mat[1][4] = C_mat[4][1] = (($(C 2 2 1 3)) + ($(C 2 2 3 1)))/2;"
echo "C_mat[1][5] = C_mat[5][1] = (($(C 2 2 2 3)) + ($(C 2 2 3 2)))/2;"

echo "C_mat[2][2] = $(C 3 3 3 3);"
echo "C_mat[2][3] = C_mat[3][2] = (($(C 3 3 1 2)) + ($(C 3 3 2 1)))/2;"
echo "C_mat[2][4] = C_mat[4][2] = (($(C 3 3 1 3)) + ($(C 3 3 3 1)))/2;"
echo "C_mat[2][5] = C_mat[5][2] = (($(C 3 3 2 3)) + ($(C 3 3 3 2)))/2;"

echo "C_mat[3][3] = (($(C 1 2 1 2)) + ($(C 1 2 2 1)))/2;"
echo "C_mat[3][4] = C_mat[4][3] = (($(C 1 2 1 3)) + ($(C 1 2 3 1)))/2;"
echo "C_mat[3][5] = C_mat[5][3] = (($(C 1 2 2 3)) + ($(C 1 2 3 2)))/2;"

echo "C_mat[4][4] = (($(C 1 3 1 3)) + ($(C 1 3 3 1)))/2;"
echo "C_mat[4][5] = C_mat[5][4] = (($(C 1 3 2 3)) + ($(C 1 3 3 2)))/2;"

echo "C_mat[5][5] = (($(C 2 3 2 3)) + ($(C 2 3 3 2)))/2;"
