
#include "Wconfig.h"

#ifdef EFG_WASP

#include "WEFG.h"
#include "WEFGsf.h"
#include "WEFGpriv.h"
#include "WEFGutil.h"
#include "Wgaussp.h"
#include "Wpss.h"
#include "Wxf.h"
#include "Wutil.h"
#include "Wcdi.h"
#include "Wdomain.h"
#include "Wtfuncs.h"

/* RCSHEADER "$Id: efgbl.c,v 1.1.1.1 2001/07/24 02:42:51 pkrysl Exp $" */

/*
   Read a body load.
   Read a body load acting within the domain of the EFG superelement.
   See User's guide for syntax and other details.
 */
void
read_body_load(WEFG_superelem_t *se, /* EFG superelement */
               W_domain_t *d /* input stream */
               )
{
  const char *input_line;
  const char *s;
  
  while ((input_line = W_get_input_line(d)) != NULL) {
    TOKENS_PARSE(input_line);
    if (TOKENS_HAVE_KEYWORD("END")) {
      if (TOKENS_HAVE_KEYWORD("BODYL")) {
        se->body_load.is_set = TRUE;
        return;
      } else
        REPORT_FATAL_ERROR(se->domain->errh, "BODYL does not end by END BODYL");
    } else {
      if (TOKENS_HAVE_KEYWORD("TIME_INDEPENDENT"))
        se->body_load.is_time_independent = TRUE;
      else
        se->body_load.is_time_independent = FALSE;

      if (TOKENS_HAVE_KEYWORD("CONSTANT"))
        se->body_load.is_constant = TRUE;
      else
        se->body_load.is_constant = FALSE;

      s = TOKEN_STR(1);
      DUPLICATE_STRING(se->body_load.body_load_expr[0], s);
      s = TOKEN_STR(2);
      DUPLICATE_STRING(se->body_load.body_load_expr[1], s);
      s = TOKEN_STR(3);
      DUPLICATE_STRING(se->body_load.body_load_expr[2], s);
    }
  }
  REPORT_FATAL_ERROR(se->domain->errh, "BODYL does not end by END BODYL");
}

#endif /* EFG_WASP  */



