#include "Wconfig.h" 
 
#ifdef EFG_WASP

#include "Wdomain.h"
#include "Welem.h"
#include "Wnode.h"
#include "Wmat3d.h"
#include "Wgaussp.h"
#include "Wxf.h"
#include "Wutil.h"
#include "Wcdi.h" 
#include "WEFG.h" 
#include "WEFGutil.h"
#include "WEFGgc.h"
#include "WEFGcr.h"
#include "WEFGpriv.h"
#include "WEFGss.h"
 

void
efg_write_tecplot(W_elem_t *el, FILE *stream, void *optdata)
{
  W_index_t *count = (W_index_t *)optdata;
  WEFG_superelem_t *se = (WEFG_superelem_t *)el->data;
  WEFG_vertex_t *v;
  WEFG_hex_volume_t *h;
  WEFG_crack_surf_t *cs;

  v = NULL;
  while ((v = (WEFG_vertex_t *)dict_next_obj(se->verts, v)) != NULL) {
    efgv_write_tecplot(v, se, stream, count);
  }
  
  loop_through_list(se->hex_volumes, h, WEFG_hex_volume_t *) {
    hex_write_tecplot_postproc_file(h, se, stream, count);
  }

  if (se->cracks) {
    loop_through_list(se->cracks, cs, WEFG_crack_surf_t *) {
      efgcr_write_tecplot_postproc_file(cs, stream, NULL, count);
    }
  }
}

  

#endif /* EFG_WASP  */
 
