#include "Wconfig.h" 
 
#ifdef EFG_WASP

#include "Wdomain.h"
#include "Welem.h"
#include "Wnode.h"
#include "Wmat3d.h"
#include "Wgaussp.h"
#include "Wxf.h"
#include "Wutil.h"
#include "Wcdi.h" 
#include "WEFG.h" 
#include "WEFGutil.h"
#include "WEFGgc.h"
#include "WEFGpriv.h"
#include "WEFGss.h"
 

void
efg_write_ve3d(W_elem_t *el, FILE *stream)
{
  WEFG_superelem_t *se = (WEFG_superelem_t *)el->data;
  WEFG_vertex_t *v;
  WEFG_hex_volume_t *h;
  WEFG_b_face_t *f;
  int i;

  fprintf(stream, "LOCLIST \"vertices\"\n");
  v = NULL;
    while ((v = (WEFG_vertex_t *)dict_next_obj(se->verts, v)) != NULL) {
    fprintf(stream, "%ld %g %g %g\n", v->id, v->loc.x, v->loc.y, v->loc.z);
  }
  fprintf(stream, "END_LOCLIST \"vertices\"\n\n");

  fprintf(stream, "CELLS\n");
  fprintf(stream, "LOCLIST \"vertices\"\n");
  loop_through_list(se->hex_volumes, h, WEFG_hex_volume_t *) {
    fprintf(stream, "H %ld ", h->id);
    FOR(i, 8) fprintf(stream, "%ld ", h->vertex[i]->id);
    fprintf(stream, "\n");
  }
  fprintf(stream, "END_CELLS\n\n");

  fprintf(stream, "BDRYPOLYS \"external boundary faces\"\n");
  fprintf(stream, "LOCLIST \"vertices\"\n");
  loop_through_list(se->b_faces, f, WEFG_b_face_t *) {
    switch (f->num_vert) {
    case 3:
      fprintf(stream, "T ");
      FOR(i, 3) {
        fprintf(stream, "%ld ", f->v[i]->id);
      }
      fprintf(stream, "\n");
      break;
    case 4:
      fprintf(stream, "Q ");
      FOR(i, 4) {
        fprintf(stream, "%ld ", f->v[i]->id);
      }
      fprintf(stream, "\n");
      break;  
    }
  }
  fprintf(stream, "END_BDRYPOLYS \"external boundary faces\"\n\n");

}




#endif /* EFG_WASP  */
