

#include "Wconfig.h"
#include "Wxf.h"
#include "Wtypes.h"
#include "Werrh.h"
#include "Wlogh.h"
#include "Wutil.h"
#include "Wmpi.h"

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <timeP.h>

/* RCSHEADER "$Id: logh.c,v 1.1.1.1 2001/07/24 02:42:51 pkrysl Exp $" */

typedef struct W_log_handler_t {
  char        *log_name;
  FILE        *log_stream;
  char         buf[2048];
}              W_log_handler_t;


struct W_log_handler_t *
W_log_new_handler (char *log_name)
{
  W_log_handler_t *lh;
  lh = NEWP_OBJ (W_log_handler_t);
  if (!lh) return NULL;
  if (!log_name)      lh->log_name = "?";
  else {
    DUPLICATE_STRING (lh->log_name, log_name);
  }
  lh->log_stream = NULL;
  if (log_name) {
    lh->log_stream = fopen (log_name, "a");
  }
  if (!lh->log_stream) lh->log_stream = stdout;
  return lh;
}

/*
   Update log.
 */
void
W_log_update (struct W_log_handler_t *lh, char *s)
{
  FILE *stream = NULL;
  if (lh) {
    stream = lh->log_stream;
  }
  fprintf(stream, "# %s\n", s);
  W_log_flush (lh);
}

/*
   Flush log.
 */
void
W_log_flush (struct W_log_handler_t *lh)
{
  if (lh) fflush(lh->log_stream);
  else    fflush (stdout);
}


