function [Dout,Dbarout] =  matd3cryspl_Ds
  Dout = sym(zeros (3,3,3,3)) ;
  Dbarout = sym(zeros (3,3,3,3)) ;
  for i = 1:3
    for j = 1:3
      for k = 1:3
        for l = 1:3    
           Dout(i,j,k,l) = D(i,j,k,l);
           Dbarout(i,j,k,l) = Dbar(i,j,k,l);
        end
      end
    end
  end
  return; 

function v = D (i, j, k, l)
     invFp = [ sym('iFp00','real') sym('iFp01','real') sym('iFp02','real');
               sym('iFp10','real') sym('iFp11','real') sym('iFp12','real');
               sym('iFp20','real') sym('iFp21','real') sym('iFp22','real') ];
     v = sym('0');
     for m = 1:3
        for n = 1:3
           for r = 1:3
              for s = 1:3
                 v = v + Dbarmat(m,n,r,s)*invFp(i,m)*invFp(j,n)*invFp(k,r)*invFp(l,s);
              end
           end
        end
     end
     return;
    
function matidx = pair_to_matidx (i,j)
    if     (i == 1 & j == 1) matidx = 1;
    elseif (i == 2 & j == 2) matidx = 2;
    elseif (i == 3 & j == 3) matidx = 3;
    elseif (i == 1 & j == 2) matidx = 4;
    elseif (i == 2 & j == 1) matidx = 4;
    elseif (i == 1 & j == 3) matidx = 5;
    elseif (i == 3 & j == 1) matidx = 5;
    elseif (i == 3 & j == 2) matidx = 6;
    elseif (i == 2 & j == 3) matidx = 6;
    else                   matidx = -1;
    end
    return;

function [matidx1,matidx2] = Dbarmatidx (i,j,k,l)
     m1 = pair_to_matidx(i,j);
     m2 = pair_to_matidx(k,l);
     % symmetrize
     if (m1 > m2) 
         matidx1 = m2;
         matidx2 = m1;
     else
         matidx1 = m1;
         matidx2 = m2;
     end
     return;
     
function v = Dbar (i, j, k, l)
     c12 = sym('c12','real');
     c11 = sym('c11','real');
     c44 = sym('c44','real');
     v = delta(i,j)*delta(k,l)*c12 + ...
         2*I(i,j,k,l)*c44 + ...
         (c11 - c12 - 2*c44)*A(i,j,k,l);
     return;

function v = Dbarmat (i, j, k, l)
     [p,q] = Dbarmatidx(i,j,k,l);
     s = sprintf ('Dbar%d%d', p, q);
     v = sym(s,'real');
     return;

function v = delta (i, j)
     if (i == j) v = 1;
     else        v = 0;
     end
     return;

function v = I (i, j, k, l)
     v = (delta (i,k)*delta(j,l) + delta(i,l)*delta(j,k))/2;
     return;

function v = A (i, j, k, l)
     a = [sym('a1','real') sym('a2','real') sym('a3','real')];
     b = [sym('b1','real') sym('b2','real') sym('b3','real')];
     c = [sym('c1','real') sym('c2','real') sym('c3','real')];
     v = (a(i)*a(j)*a(k)*a(l) + b(i)*b(j)*b(k)*b(l) + c(i)*c(j)*c(k)*c(l));
     return;

