
void
construct_ramp(WEFG_hex_volume_t *h, double ksi, double eta, double tht,
               double R, double D_R[3])
{
  int i;
  W_float_t n[8], n_ksi[8], n_eta[8], n_theta[8], n_x[8], n_y[8], n_z[8];
  W_float_t J[3][3], inv_J[3][3];
#define X 0
#define Y 1
#define Z 2

  solid_compute_N_matrix(n, ksi, eta, tht);
  solid_jacobian_matrix(J, ksi, eta, tht, ALL_REF_COORDS);
  solid_invert_jacobian_matrix(J, inv_J);
  solid_compute_N_ksi_matrix(    n_ksi, ksi, eta, tht);
  solid_compute_N_eta_matrix(    n_eta, ksi, eta, tht);
  solid_compute_N_theta_matrix(n_theta, ksi, eta, tht);
  solid_compute_N_x_matrix(inv_J, n_ksi, n_eta, n_theta, n_x);
  solid_compute_N_y_matrix(inv_J, n_ksi, n_eta, n_theta, n_y);
  solid_compute_N_z_matrix(inv_J, n_ksi, n_eta, n_theta, n_z);
  R = D_R[X] = D_R[Y] = D_R[Z] = 0;
  FOR(i, 8) {
    if (h->vertex[i]->fe_node == NULL) {
      R      += n[i];
      D_R[X] += n_x[i];
      D_R[Y] += n_y[i];
      D_R[Z] += n_z[i];
    }
  }
}
