#!/bin/ksh

function Line {
        echo $*
}

function Open {
        echo '<'$*'>'
}

function Close {
        echo '</'$1'>'
}

Open html
Open head
Open title
Line Petr Krysl: WASP reference manual page 
Close title
Close head

Open body 

Open H1
  Line WASP  "Programer's Reference Manual"
Close H1

Open center
  Line "WASP (C) 1994-2000, Petr Krysl"
  Open p
    Line "<B>WASP</B> stands for (<B>W</B>)ave propagation and vibration (<B>A</B>)nalysi(<B>S</B>) 
(<B>P</B>)ackage."
    Open p
      Line "WASP is copyright of Petr Krysl. The source code of 
this package is protected by the GNU General Public License."
    Close p
  Close p
Close center

Open h2
Line Readers
Close h2

Open ul
for n in W_*_reader.html
do
        Open li
           Open a href=\"$n\" 
              Line ${n%%.html}
           Close a
        Close li
done
Close ul

function sect_for_prefix {
        prefix=$1
        title=$2
        Open h2
                Line $title
        Close h2
        Open ul
        for n in ${prefix}_*.html
        do
                Open li
                   Open a href=\"$n\" 
                       Line ${n%%.html}
                   Close a
                Close li
        done
        Close ul
}

sect_for_prefix WD Domain
sect_for_prefix WN Node
sect_for_prefix WE Element
sect_for_prefix WL "Loads"
sect_for_prefix WM "Materials"
sect_for_prefix WTF "Time functions"
sect_for_prefix WM3D "Material models for solids"
sect_for_prefix WM1D "Material models for line elements"
sect_for_prefix WHR "History writer"
sect_for_prefix W_cd "Central-difference Integrator"
sect_for_prefix W_newmark "Implicit Newmark Integrator"
sect_for_prefix WEH "Error handling"
sect_for_prefix WC "Contact"
sect_for_prefix WPC "Penalty contact"
sect_for_prefix WBC "Displacement boundary conditions"
sect_for_prefix WIVC "Initial conditions"
sect_for_prefix WG "Gauss integration"
sect_for_prefix W_log "Logging utilities"
sect_for_prefix W_modr "Model reduction"
sect_for_prefix W_mpi "MPI parallelization"
sect_for_prefix WO "Options processing"
sect_for_prefix WVS "Value set"

Close body

Close html


