#ifndef NTSUB
# error NTSUB not defined
#endif
#ifndef QDIM
# error QDIM not defined
#endif

/* RCSHEADER "$Id: transf.c,v 1.1.1.1 2001/07/24 02:42:51 pkrysl Exp $" */

#define TSUBDIM 3
#undef TDIM
#define TDIM NTSUB*TSUBDIM


void
R_is_block_diag_T_times_Q (double R[TDIM][QDIM],
                           double TSUB[TSUBDIM][TSUBDIM],
                           double Q[TDIM][QDIM]                           
                           )
{
  /*
    Procedure provides product of block-diagonal transformation matrix T
    with another (rectangular) matrix Q.
    
    Transformation matrix T is composed of submatrices of rank TSUBDIM
    on diagonal.
  */
  int I,J,II,III,M;
  
  /*  MULTIPLICATION T(TDIM,TDIM)*Q(TDIM,RQ)=R(TDIM,RQ) */

  FOR (J, QDIM) {
    FOR (I, TDIM) {
      II  =(I/TSUBDIM)*TSUBDIM;
      III = I-II;
      R[I][J] = TSUB[III][0] * Q[II][J];
      for (M=1; M<TSUBDIM; M++) {
        R[I][J] += TSUB[III][M]*Q[II+M][J];
      }
    }
  }
}

void
R_is_Q_times_transp_block_diag_T (double R[QDIM][TDIM],
                                  double Q[QDIM][TDIM],
                                  double TSUB[TSUBDIM][TSUBDIM]
                                  )
{
  /*
    Procedure provides product of block-diagonal transformation matrix T
    with another (rectangular) matrix Q.
    
    Transformation matrix T is composed of submatrices of rank TSUBDIM
    on diagonal.
  */
  int I,J,JJ,JJJ,M;
  
  /*  MULTIPLICATION Q(RQ,TDIM)*transp T(TDIM,TDIM)=R(RQ,TDIM) */

  FOR (I, QDIM) {
    FOR (J, TDIM) {
      JJ  = (J/TSUBDIM)*TSUBDIM;
      JJJ = J-JJ;
      R[I][J] = Q[I][JJ] * TSUB[JJJ][0];
      for (M=1; M<TSUBDIM; M++) {
        R[I][J] += Q[I][JJ+M] * TSUB[JJJ][M];
      }
    }
  }
}

